/*<License>

    Copyright (C) 2007, Cashware D&S

    This program is public software; you can use it and/or
    redistribute it and/or modify it under the terms of
    the Xpeaker Public License, version 1.

    This program is distributed in the hope that it will
    be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A
    PARTICULAR PURPOSE.  See the Xpeaker Public License
    for more details.

    You should have received a copy of the Xpeaker
    Public License along with this program; if not, you
    can read it at http://www.cashware.biz

</License>*/

package org.xpeak.xpeaking.examples.barcode;

import java.io.File;
import java.net.URL;

import org.xpeak.xpeaker.common.XInterfaceXpeakConstants;
import org.xpeak.xpeaker.common.xml.data.XDataEvent;
import org.xpeak.xpeaker.common.xml.data.events.barcode.XDataEventBarcodeDataRead;
import org.xpeak.xpeaking.manager.XClassManager;
import org.xpeak.xpeaking.services.barcode.XClassServiceBarcode;

public class Simplest implements XInterfaceXpeakConstants {

	
	public static void main( String[] args) 
	{
		try {
			File XpeakingProperties = new File( "Xpeaking.properties");
			
			System.out.println( "Loading Xpeak Services from repository " + XpeakingProperties.getAbsolutePath());
			
			XClassManager.getReference().setRepository( new URL( "file:///" + XpeakingProperties.getAbsolutePath()));

			XClassServiceBarcode Barcode = ( XClassServiceBarcode) XClassManager.getReference().getService( "Barcode");
			
			Barcode.initialize( true);

			System.out.println( "Insert a barcode before 10 seconds");
			
			if( Barcode.read( 10000).Result.getValue() == XPEAK_RESULT_OK) {
				
				XDataEvent Event = Barcode.waitForBarcodeDataRead();
				
				if( Event.Result.getValue() == XPEAK_RESULT_DATA_READ) {				

					XDataEventBarcodeDataRead DataRead = new XDataEventBarcodeDataRead();
					
					Event.cast( DataRead);
					
					System.out.println( "Barcode Read=" + DataRead.Data.getString());
				}
			}
			
			Barcode.shutdown( false);
		} catch( Exception e) {
			e.printStackTrace();
		};
		
		System.exit( 0);
	}

}
