/*<License>

    Copyright (C) 2007, Cashware D&S

    This program is public software; you can use it and/or
    redistribute it and/or modify it under the terms of
    the Xpeaker Public License, version 1.

    This program is distributed in the hope that it will
    be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A
    PARTICULAR PURPOSE.  See the Xpeaker Public License
    for more details.

    You should have received a copy of the Xpeaker
    Public License along with this program; if not, you
    can read it at http://www.cashware.biz

</License>*/

package org.xpeak.xpeaking.examples.card;

import java.io.File;
import java.net.URL;

import org.xpeak.xpeaker.common.XInterfaceXpeakConstants;
import org.xpeak.xpeaker.common.tools.XClassTimer;
import org.xpeak.xpeaker.common.xml.data.answers.card.XDataAnswerCardGetCapabilities;
import org.xpeak.xpeaker.common.xml.data.answers.card.XDataAnswerCardMagneticRead;
import org.xpeak.xpeaking.manager.XClassManager;
import org.xpeak.xpeaking.services.card.XClassServiceCard;

public class Simplest implements XInterfaceXpeakConstants {

	
	public static void main( String[] args) 
	{
		try {
			File XpeakingProperties = new File( "Xpeaking.properties");
			
			System.out.println( "Loading Xpeak Services from repository " + XpeakingProperties.getAbsolutePath());
			
			XClassManager.getReference().setRepository( new URL( "file:///" + XpeakingProperties.getAbsolutePath()));

			XClassServiceCard Card = ( XClassServiceCard) XClassManager.getReference().getService( "Card");
			
			Card.initialize( true);

			System.out.println( "Insert a card before 10 seconds");
			
			if( Card.enableInsert( 10000, false, true, false).Result.getValue() == XPEAK_RESULT_OK) {
				if( Card.waitForCardInserted().Result.getValue() == XPEAK_RESULT_MEDIA_INSERTED) {
					
					System.out.println("Reading Track-2");

					XDataAnswerCardMagneticRead DataRead = Card.magneticRead( false, true, false);
				
					if( DataRead.getDeviceId().indexOf( "Acme") >= 0)
						XClassTimer.sleep( 2000)
					; 
					
					if( DataRead.Result.getValue() == XPEAK_RESULT_OK) {
						System.out.println( "Track-2=" + DataRead.Track2Data.getString());
					}
					
					System.out.println("Take the card");

					if( Card.eject( 10000).Result.getValue() == XPEAK_RESULT_OK) {
						if( Card.waitForCardTaken().Result.getValue() != XPEAK_RESULT_MEDIA_TAKEN)
							Card.retract()
						;
					}
				}
			}
			
			Card.shutdown( false);
		} catch( Exception e) {
			e.printStackTrace();
		};
		
		System.exit( 0);
	}

}
