/*<License>

    Copyright (C) 2007, Cashware D&S

    This program is public software; you can use it and/or
    redistribute it and/or modify it under the terms of
    the Xpeaker Public License, version 1.

    This program is distributed in the hope that it will
    be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A
    PARTICULAR PURPOSE.  See the Xpeaker Public License
    for more details.

    You should have received a copy of the Xpeaker
    Public License along with this program; if not, you
    can read it at http://www.cashware.biz

</License>*/

package org.xpeak.xpeaking.examples.cash;

import java.io.File;
import java.net.URL;

import org.xpeak.xpeaker.common.XClassXpeakConstants;
import org.xpeak.xpeaker.common.XInterfaceXpeakConstants;
import org.xpeak.xpeaker.common.xml.data.XDataEvent;
import org.xpeak.xpeaker.common.xml.data.XTypeConstant;
import org.xpeak.xpeaker.common.xml.data.answers.cash.XDataAnswerCashAcceptDeposit;
import org.xpeak.xpeaker.common.xml.data.answers.cash.XDataAnswerCashDeposit;
import org.xpeak.xpeaker.common.xml.data.answers.cash.XDataAnswerCashDispense;
import org.xpeak.xpeaker.common.xml.data.answers.cash.XDataAnswerCashEnableInsert;
import org.xpeak.xpeaker.common.xml.data.answers.cash.XDataAnswerCashGetCashUnits;
import org.xpeak.xpeaker.common.xml.data.commands.cash.XDataCommandCashDispense;
import org.xpeak.xpeaker.common.xml.data.events.barcode.XDataEventBarcodeDataRead;
import org.xpeak.xpeaking.manager.XClassManager;
import org.xpeak.xpeaking.services.cash.XClassServiceCash;

public class Simplest implements XInterfaceXpeakConstants {

	public static void main( String[] args) 
	{
		try {
			File XpeakingProperties = new File( "Xpeaking.properties");
			
			System.out.println( "Loading Xpeak Services from repository " + XpeakingProperties.getAbsolutePath());
			
			XClassManager.getReference().setRepository( new URL( "file:///" + XpeakingProperties.getAbsolutePath()));

			XClassServiceCash Cash = ( XClassServiceCash) XClassManager.getReference().getService( "Cash");
			
			Cash.initialize( true);

			int Readed;
			
			do {
				System.out.println( "Cash menu: ");			
				System.out.println( "1 -> Get cash units information");
				System.out.println( "2 -> Dispense 20 EUR");
				System.out.println( "3 -> Deposit operation");
				System.out.println( "E -> Exit");
			
				Readed = System.in.read();
				
				switch(( char) Readed) {
				
					case '1':
						XDataAnswerCashGetCashUnits GetCashUnitAnswer = Cash.getCashUnits( true, new int[] {});
						
						System.out.println( "GetCashUnit. Result: " + XClassXpeakConstants.get( GetCashUnitAnswer.Result.getValue()));	
						
						if( GetCashUnitAnswer.CashUnits != null) {
							for( int i = 0; i < GetCashUnitAnswer.CashUnits.length; i++) {
								
								System.out.println( "GetCashUnit. Cassette " + i + " Id: " 			+ GetCashUnitAnswer.CashUnits[ i].Id);	
								System.out.println( "GetCashUnit. Cassette " + i + " Type: " 		+ XClassXpeakConstants.get( GetCashUnitAnswer.CashUnits[ i].Type.getValue()));	
								System.out.println( "GetCashUnit. Cassette " + i + " Item Type: " 	+ XClassXpeakConstants.get( GetCashUnitAnswer.CashUnits[ i].ItemsType.getValue()));	
								System.out.println( "GetCashUnit. Cassette " + i + " Status: " 		+ XClassXpeakConstants.get( GetCashUnitAnswer.CashUnits[ i].Status.getValue()));	
								System.out.println( "GetCashUnit. Cassette " + i + " Locked: " 		+ GetCashUnitAnswer.CashUnits[ i].Locked);	
								
								if( GetCashUnitAnswer.CashUnits[ i].Denominations != null) {
									for( int j = 0; j < GetCashUnitAnswer.CashUnits[ i].Denominations.length; j++) 
										System.out.println( "GetCashUnit. Cassette " + i + " Denomination: "  + GetCashUnitAnswer.CashUnits[ i].Denominations[ j].Value + "-" + GetCashUnitAnswer.CashUnits[ i].Denominations[ j].Currency + "-"+ GetCashUnitAnswer.CashUnits[ i].Denominations[ j].Category +" = "  + GetCashUnitAnswer.CashUnits[ i].Denominations[ j].Count)
									;	
								}
							}
						}
					break;
					case '2':
						XDataCommandCashDispense Dispense  = new XDataCommandCashDispense();
						
						Dispense.Present = true;
						Dispense.Timeout = -1;
						Dispense.Position = new XTypeConstant( XInterfaceXpeakConstants.XPEAK_POSITION_RIGHT);
						Dispense.addDenomination( "EUR", 20, 1);
						
						XDataAnswerCashDispense DispenseAnswer = Cash.dispense( Dispense);
						
						System.out.println( "Dispense. Result: " + XClassXpeakConstants.get( DispenseAnswer.Result.getValue()));	
						
						if( DispenseAnswer.Denominations != null) {
							for( int i = 0; i < DispenseAnswer.Denominations.length; i++)							
								System.out.println( "Dispense. CassetteId: " + DispenseAnswer.Denominations[ i].CashUnitId + " Denominations: " + DispenseAnswer.Denominations[ i].Currency + "-" + DispenseAnswer.Denominations[ i].Value + " -> " + DispenseAnswer.Denominations[ i].Count)
							;	
						}
					break;
					case '3':
						XDataAnswerCashEnableInsert EnableInsertAnswer = Cash.enableInsert( XInterfaceXpeakConstants.XPEAK_COMMAND_DEPOSIT, XInterfaceXpeakConstants.XPEAK_POSITION_RIGHT, -1);
						
						System.out.println( "EnableInsert. Result: " + XClassXpeakConstants.get( EnableInsertAnswer.Result.getValue()));
						
						System.out.println( "Waiting for cash insertion");
						
						Cash.waitForCashInserted();
						
						System.out.println( "Cash inserted");
						
						XDataAnswerCashDeposit DepositAnswer = Cash.deposit( -1);
						
						System.out.println( "Deposit. Result: " + XClassXpeakConstants.get( DepositAnswer.Result.getValue()));
						
						for( int i = 0; i < DepositAnswer.Denominations.length; i++)							
							System.out.println( "Deposit. Denominations: " + DepositAnswer.Denominations[ i].Currency + "-" + DepositAnswer.Denominations[ i].Value + " -> " + DepositAnswer.Denominations[ i].Count)
						;
						
						XDataAnswerCashAcceptDeposit AccpetDepositAnswer = Cash.acceptDeposit();
						
						System.out.println( "AccepetDeposit. Result: " + XClassXpeakConstants.get( AccpetDepositAnswer.Result.getValue()));
						
						if( AccpetDepositAnswer.Denominations != null) {
							for( int i = 0; i < AccpetDepositAnswer.Denominations.length; i++)							
								System.out.println( "Accepted. Denominations: " + AccpetDepositAnswer.Denominations[ i].Currency + "-" + AccpetDepositAnswer.Denominations[ i].Value + "-" + AccpetDepositAnswer.Denominations[ i].Category + " -> " + AccpetDepositAnswer.Denominations[ i].Count)
							;
						}
					break;
				}	
					
		    	System.in.read();
				System.in.read();
		    	
			} while(( char) Readed != 'E' && ( char) Readed != 'e');	
			
			Cash.shutdown( false);
		} catch( Exception e) {
			e.printStackTrace();
		};
		
		System.exit( 0);
	}
}
